package emulator.hardware.clock;

import java.util.Observer;

/** System clock interface.
 *  Synchronized components have to acquire a ClockHandle each. */
public interface Clock {
	/** acquire clock handle for a component. */
	ClockHandle acquireHandle();
	/** release clock handle of a component. */
	void releaseHandle(ClockHandle handle);
	void addClockSpeedObserver(Observer clockSpeedObserver);
}
