package emulator.hardware.debug;

public class AddressStatistics {
	private int execution_counter;
	private int cycle_counter;
	private int address;
	
	public AddressStatistics(int address)
	{
		this.address = address;
		reset();
	}
	
	public void reset()
	{
		execution_counter = 0;
		cycle_counter = 0;
	}
	
	void countExecution(int cycles)
	{
		execution_counter++;
		cycle_counter += cycles;
	}
	
	public int getAddress()
	{
		return address;
	}
	
	public int getExecutionCounter()
	{
		return execution_counter;
	}
	
	public int getCycleCounter()
	{
		return cycle_counter;
	}

	public String getToolTip() {
		return "Count: " + execution_counter
			+ "  Cycles: " + cycle_counter
			+ "  Avg. Cycles: " + (execution_counter > 0 ? cycle_counter / execution_counter : 0);
	}
}
