package emulator.hardware.nmos6502.commands;

import emulator.EmulatorException;
import emulator.hardware.nmos6502.Command;
import emulator.hardware.nmos6502.CommandSet;
import emulator.hardware.nmos6502.Cpu6502;
import emulator.hardware.nmos6502.Flags6502;
import emulator.hardware.nmos6502.Operand;
import emulator.hardware.nmos6502.operands.Displacement;

/** BEQ (Branch on EQual) */
public class BEQ implements Command {

	@Override
	public void execute(Cpu6502 cpu, Operand operand) throws EmulatorException {
		if (cpu.getFlags().getZero())
			cpu.branch(operand.getByte());
	}

	@Override
	public String getName() {
		return "BEQ";
	}

	@Override
	public void register(CommandSet cset) {
		cset.defineCommand(0xF0, this, new Displacement(Flags6502.BIT_ZERO, true));
	}

}
