package emulator.hardware.nmos6502.commands;

import emulator.EmulatorException;
import emulator.hardware.nmos6502.Command;
import emulator.hardware.nmos6502.CommandSet;
import emulator.hardware.nmos6502.Cpu6502;
import emulator.hardware.nmos6502.Flags6502;
import emulator.hardware.nmos6502.Operand;
import emulator.hardware.nmos6502.operands.NoOperand;

/** CLI (CLear Interrupt) */
public class CLI implements Command {

	@Override
	public void execute(Cpu6502 cpu, Operand operand) throws EmulatorException {
		Flags6502 flags = cpu.getFlags();
		flags.setInterrupt(false);
		cpu.setFlags(flags);
	}

	@Override
	public String getName() {
		return "CLI";
	}

	@Override
	public void register(CommandSet cset) {
		cset.defineCommand(0x58, this, new NoOperand());
	}

}
