package emulator.hardware.nmos6502.commands;

import emulator.EmulatorException;
import emulator.hardware.nmos6502.Command;
import emulator.hardware.nmos6502.CommandSet;
import emulator.hardware.nmos6502.Cpu6502;
import emulator.hardware.nmos6502.Operand;
import emulator.hardware.nmos6502.operands.NoOperand;

/** NOP (No OPeration)
 *  
 *  Affects Flags: none
 *  
 *  MODE           SYNTAX       HEX LEN TIM
 *  Implied       NOP           $EA  1   2
 *  
 *  NOP is used to reserve space for future modifications or effectively REM
 *  out existing code. 
 */
public class NOP implements Command {

	@Override
	public void execute(Cpu6502 cpu, Operand operand) throws EmulatorException {
		/* NOP */
	}

	@Override
	public String getName() {
		return "NOP";
	}

	@Override
	public void register(CommandSet cset) {
		cset.defineCommand(0xEA, this, new NoOperand());
	}

}
