package emulator.hardware.nmos6502.commands;

import emulator.EmulatorException;
import emulator.hardware.nmos6502.Command;
import emulator.hardware.nmos6502.CommandSet;
import emulator.hardware.nmos6502.Cpu6502;
import emulator.hardware.nmos6502.Operand;
import emulator.hardware.nmos6502.operands.NoOperand;
import emulator.hardware.nmos6502.stack.StackData;

/** PHP (PusH Processor status) */
public class PHP implements Command {

	@Override
	public void execute(Cpu6502 cpu, Operand operand) throws EmulatorException {
		cpu.pushByte((int) cpu.getFlags().getNumber(), StackData.DATA_FLAGS);
	}

	@Override
	public String getName() {
		return "PHP";
	}

	@Override
	public void register(CommandSet cset) {
		cset.defineCommand(0x08, this, new NoOperand(), 3);
	}

}
