package emulator.hardware.nmos6502.commands;

import emulator.hardware.memory.UnmappedMemoryException;
import emulator.hardware.nmos6502.Command;
import emulator.hardware.nmos6502.CommandSet;
import emulator.hardware.nmos6502.Cpu6502;
import emulator.hardware.nmos6502.Flags6502;
import emulator.hardware.nmos6502.Operand;
import emulator.hardware.nmos6502.operands.*;

/** SEI (SEt Interrupt) */
public class SEI implements Command {

	@Override
	public void execute(Cpu6502 cpu, Operand operand) throws OperandException,
			UnmappedMemoryException, IllegalOpcodeException {
		Flags6502 flags = cpu.getFlags();
		flags.setInterrupt(true);
		cpu.setFlags(flags);
	}

	@Override
	public String getName() {
		return "SEI";
	}

	@Override
	public void register(CommandSet cset) {
		cset.defineCommand(0x78, this, new NoOperand());
	}

}
