package emulator.hardware.nmos6502.commands;

import emulator.EmulatorException;
import emulator.hardware.nmos6502.Command;
import emulator.hardware.nmos6502.CommandSet;
import emulator.hardware.nmos6502.Cpu6502;
import emulator.hardware.nmos6502.Operand;
import emulator.hardware.nmos6502.operands.NoOperand;

public class TSX implements Command {

	@Override
	public void execute(Cpu6502 cpu, Operand operand) throws EmulatorException {
		cpu.setX(cpu.getSP());
	}

	@Override
	public String getName() {
		return "TSX";
	}

	@Override
	public void register(CommandSet cset) {
		cset.defineCommand(0xBA, this, new NoOperand());
	}

}
