package emulator.hardware.nmos6502.commands;

import emulator.hardware.HwByte;
import emulator.hardware.memory.UnmappedMemoryException;
import emulator.hardware.nmos6502.Command;
import emulator.hardware.nmos6502.CommandSet;
import emulator.hardware.nmos6502.Cpu6502;
import emulator.hardware.nmos6502.Flags6502;
import emulator.hardware.nmos6502.Operand;
import emulator.hardware.nmos6502.operands.NoOperand;
import emulator.hardware.nmos6502.operands.OperandException;

public class TXA implements Command {

	@Override
	public void execute(Cpu6502 cpu, Operand operand) throws OperandException,
			UnmappedMemoryException, IllegalOpcodeException {
		HwByte value = cpu.getX();
		cpu.setAccu(value);
		Flags6502 flags = cpu.getFlags();
		flags.setNZFromValue(value);
		cpu.setFlags(flags);
	}

	@Override
	public String getName() {
		return "TXA";
	}

	@Override
	public void register(CommandSet cset) {
		cset.defineCommand(0x8A, this, new NoOperand());
	}

}
