package emulator.hardware.nmos6502.commands;

import emulator.hardware.memory.UnmappedMemoryException;
import emulator.hardware.nmos6502.Command;
import emulator.hardware.nmos6502.CommandSet;
import emulator.hardware.nmos6502.Cpu6502;
import emulator.hardware.nmos6502.Operand;
import emulator.hardware.nmos6502.operands.*;

/** TXS (Transfer X to Stack ptr) */
public class TXS implements Command {

	@Override
	public void execute(Cpu6502 cpu, Operand operand) throws OperandException,
			UnmappedMemoryException, IllegalOpcodeException {
		cpu.setSP(cpu.getX());
	}

	@Override
	public String getName() {
		return "TXS";
	}

	@Override
	public void register(CommandSet cset) {
		cset.defineCommand(0x9A, this, new NoOperand());
	}

}
