package emulator.hardware.nmos6502.operands;

import emulator.assembler.SymbolTable;
import emulator.hardware.HwByte;
import emulator.hardware.HwWord;
import emulator.hardware.nmos6502.Cpu6502;
import emulator.hardware.nmos6502.Operand;
import emulator.support.NullOperandEval;
import emulator.support.OperandEval;
import emulator.util.MemoryPtr;

public class NoOperand implements Operand {

	@Override
	public HwByte getByte() throws OperandException {
		throw new OperandException("getByte() on no operand called", this);
	}

	@Override
	public HwWord getWord() throws OperandException {
		throw new OperandException("getWord() on no operand called", this);
	}

	@Override
	public void init(Cpu6502 cpu) {
		/* no op */
	}

	@Override
	public void setByte(HwByte data) throws OperandException {
		throw new OperandException("setByte() on no operand called", this);
	}

	@Override
	public void setWord(HwWord data) throws OperandException {
		throw new OperandException("setWord() on no operand called", this);
	}

	@Override
	public String getString() {
		return "";
	}

	@Override
	public int getByteCount() {
		return 0;
	}

	@Override
	public String getString(MemoryPtr mem_ref, SymbolTable symbols) {
		return "";
	}

	@Override
	public int getExtraCycles() {
		return 0;
	}

	@Override
	public OperandEval getEvaluator(MemoryPtr mem_ref) {
		return new NullOperandEval();
	}

}
