package emulator.hardware.nmos6502.stack;

public class StackData {
	public static final int DATA_EMPTY = 0;
	public static final int DATA_BYTE = 1;
	public static final int DATA_ADDRESS_LOW = 2;
	public static final int DATA_ADDRESS_HIGH = 3;
	public static final int DATA_FLAGS = 4;
	
	public static final int SOURCE_UNKNOWN = 0;
	public static final int SOURCE_INTERRUPT = 1;
	public static final int SOURCE_BREAK = 2;
	public static final int SOURCE_JUMP = 3;
	
	private int type;
	private int source;
	
	public StackData() {
		clearEntry();
	}
	
	/**
	 * @return the type
	 */
	public int getType() {
		return type;
	}
	/**
	 * @param type the type to set
	 */
	public void setType(int type) {
		this.type = type;
	}
	/**
	 * @return the source
	 */
	public int getSource() {
		return source;
	}
	/**
	 * @param source the source to set
	 */
	public void setSource(int source) {
		this.source = source;
	}

	public void clearEntry() {
		type = DATA_EMPTY;
		source = SOURCE_UNKNOWN;
	}
	
}
