package emulator.support;

import emulator.hardware.HwByte;
import emulator.hardware.HwWord;
import emulator.util.MemoryPtr;

public class AbsoluteOperandEval implements OperandEval {

	MemoryPtr instruction;
	
	public AbsoluteOperandEval(MemoryPtr ptr) {
		instruction = ptr;
	}

	@Override
	public String getDetails(CpuState cpu_state) {
		int old_address = instruction.getAddress();
		int operand = instruction.getWordOp();
		instruction.setAddress(operand);
		String result = "($" + new HwWord(operand) + ") -> $" + new HwByte(instruction.getByteOp());
		instruction.setAddress(old_address);
		return result;
	}

	@Override
	public boolean isAddress() {
		return true;
	}

	@Override
	public int getAddress(CpuState cpu_state) {
		return instruction.getWordOp();
	}

	@Override
	public boolean isIndirect() {
		return false;
	}

}
