package emulator.support;

import emulator.hardware.HwByte;
import emulator.hardware.HwWord;
import emulator.util.MemoryPtr;

public class AbsoluteYOperandEval implements OperandEval {

	MemoryPtr instruction;
	
	public AbsoluteYOperandEval(MemoryPtr ptr) {
		instruction = ptr;
	}

	@Override
	public String getDetails(CpuState cpu_state) {
		int old_address = instruction.getAddress();
		int reg_y = cpu_state.getValue("Y");
		int operand = instruction.getWordOp();
		instruction.setAddress(operand);
		String result = "($" + new HwWord(operand) + " + $" + new HwByte(reg_y) + ") -> $" + new HwByte(instruction.getByteOp(reg_y));
		instruction.setAddress(old_address);
		return result;
	}

	@Override
	public boolean isAddress() {
		return true;
	}

	@Override
	public int getAddress(CpuState cpu_state) {
		return instruction.getWordOp()+cpu_state.getValue("Y");
	}

	@Override
	public boolean isIndirect() {
		return false;
	}
}
