package emulator.support;

import emulator.hardware.HwWord;
import emulator.util.MemoryPtr;

public class IndirectAddressOperandEval implements OperandEval {

	MemoryPtr instruction;
	
	public IndirectAddressOperandEval(MemoryPtr ptr) {
		instruction = ptr; 
	}

	@Override
	public String getDetails(CpuState cpu_state) {
		int old_address = instruction.getAddress();
		int address = instruction.getWordOp();
		instruction.setAddress(address);
		int value = instruction.getWordOp();
		instruction.setAddress(old_address);
		return "($" + new HwWord(address) + ") -> $" + new HwWord(value);
	}

	@Override
	public boolean isAddress() {
		return true;
	}

	@Override
	public int getAddress(CpuState cpu_state) {
		int old_address = instruction.getAddress();
		int address = instruction.getWordOp();
		instruction.setAddress(address);
		int value = instruction.getWordOp();
		instruction.setAddress(old_address);
		return value;
	}

	@Override
	public boolean isIndirect() {
		return true;
	}
}
