package emulator.support;

import emulator.hardware.HwByte;
import emulator.hardware.HwWord;
import emulator.util.MemoryPtr;

public class IndirectXOperandEval implements OperandEval {

	MemoryPtr instruction;
	
	public IndirectXOperandEval(MemoryPtr ptr) {
		instruction = ptr;
	}

	@Override
	public String getDetails(CpuState cpu_state) {
		int old_address = instruction.getAddress();
		int address = instruction.getByteOp();
		int reg_x = cpu_state.getValue("X");
		int zp_adr = (address+reg_x) & 0xff;
		instruction.setAddress(zp_adr);
		int ptr = instruction.getWordOp();
		instruction.setAddress(ptr);
		int value = instruction.getByteOp();
		String result = "(($"+new HwByte(address)+" + $"+new HwByte(reg_x) + " -> $"+new HwByte(zp_adr)+") -> $"+new HwWord(ptr)+") -> $"+new HwByte(value);
		instruction.setAddress(old_address);
		return result;
	}

	@Override
	public boolean isAddress() {
		return true;
	}

	@Override
	public int getAddress(CpuState cpu_state) {
		int old_address = instruction.getAddress();
		int address = instruction.getByteOp();
		int reg_x = cpu_state.getValue("X");
		int zp_adr = (address+reg_x) & 0xff;
		instruction.setAddress(zp_adr);
		int ptr = instruction.getWordOp();
		instruction.setAddress(old_address);
		return ptr;
	}

	@Override
	public boolean isIndirect() {
		return true;
	}
}
