package emulator.support;

import emulator.hardware.HwByte;
import emulator.hardware.HwWord;
import emulator.util.MemoryPtr;

public class IndirectYOperandEval implements OperandEval {

	MemoryPtr instruction;
	
	public IndirectYOperandEval(MemoryPtr ptr) {
		instruction = ptr;
	}

	@Override
	public String getDetails(CpuState cpu_state) {
		int old_address = instruction.getAddress();
		int zp_addr = instruction.getByteOp();
		instruction.setAddress(zp_addr);
		int ptr = instruction.getWordOp();
		int reg_y = cpu_state.getValue("Y");
		int address = ptr+reg_y;
		instruction.setAddress(address);
		int value = instruction.getByteOp();
		String result = "(($"+new HwByte(zp_addr)+") + Y -> $"+new HwWord(ptr)+" + $"+new HwByte(reg_y)+" -> $"+new HwWord(address)+") -> $"+new HwByte(value);
		instruction.setAddress(old_address);
		return result;
	}

	@Override
	public boolean isAddress() {
		return true;
	}

	@Override
	public int getAddress(CpuState cpu_state) {
		int old_address = instruction.getAddress();
		int zp_addr = instruction.getByteOp();
		instruction.setAddress(zp_addr);
		int ptr = instruction.getWordOp();
		int reg_y = cpu_state.getValue("Y");
		int address = ptr+reg_y;
		instruction.setAddress(old_address);
		return address;
	}

	@Override
	public boolean isIndirect() {
		return true;
	}
}
