package emulator.support;

import emulator.hardware.HwByte;
import emulator.util.MemoryPtr;

public class ZeroPageXOperandEval implements OperandEval {

	MemoryPtr instruction;

	public ZeroPageXOperandEval(MemoryPtr ptr) {
		instruction = ptr;
	}

	@Override
	public String getDetails(CpuState cpu_state) {
		int old_address = instruction.getAddress();
		int reg_x = cpu_state.getValue("X");
		int operand = instruction.getByteOp();
		instruction.setAddress((operand+reg_x) & 0xff);
		String result = "($" + new HwByte(operand) + " + $" + new HwByte(reg_x) + ") -> $" + new HwByte(instruction.getByteOp());
		instruction.setAddress(old_address);
		return result;
	}

	@Override
	public boolean isAddress() {
		return true;
	}

	@Override
	public int getAddress(CpuState cpu_state) {
		return (instruction.getByteOp() + cpu_state.getValue("X")) & 0xff;
	}

	@Override
	public boolean isIndirect() {
		return false;
	}
}
