package emulator.support;

import emulator.hardware.HwByte;
import emulator.util.MemoryPtr;

public class ZeroPageYOperandEval implements OperandEval {

	MemoryPtr instruction;

	public ZeroPageYOperandEval(MemoryPtr ptr) {
		instruction = ptr;
	}

	@Override
	public String getDetails(CpuState cpu_state) {
		int old_address = instruction.getAddress();
		int reg_y = cpu_state.getValue("Y");
		int operand = instruction.getByteOp();
		instruction.setAddress((operand+reg_y) & 0xff);
		String result = "($" + new HwByte(operand) + " + $" + new HwByte(reg_y) + ") -> $" + new HwByte(instruction.getByteOp());
		instruction.setAddress(old_address);
		return result;
	}

	@Override
	public boolean isAddress() {
		return true;
	}

	@Override
	public int getAddress(CpuState cpu_state) {
		return (instruction.getByteOp() + cpu_state.getValue("Y")) & 0xff;
	}

	@Override
	public boolean isIndirect() {
		return false;
	}
}
