package emulator.unittest.hardware.memory;


import static org.junit.Assert.assertEquals;

import org.junit.Before;
import org.junit.Test;

import emulator.EmulatorException;
import emulator.hardware.debug.BusWatchException;
import emulator.hardware.memory.DebugMemoryBlock;

public class DebugMemoryReadWatchTest {

	private DebugMemoryBlock memory;

	@Before
	public void setUp() throws Exception {
		memory = new DebugMemoryBlock(0x1000);
		memory.enableReadWatch(0x200, 0x2ff, true);
	}

	@Test(expected= BusWatchException.class)
	public void testReadWatchInside() throws EmulatorException
	{
		memory.read(0x200);
	}

	@Test
	public void testReadWatchOutside() throws EmulatorException
	{
		assertEquals(0, memory.read(0x300));
	}

	@Test
	public void testReadWatchIgnoresWrite() throws EmulatorException
	{
		memory.write(0x200, 0xAA);
	}
}
