package emulator.unittest.hardware.nmos6502.commands;

import static org.junit.Assert.assertEquals;

import org.junit.Test;

import emulator.EmulatorException;
import emulator.hardware.nmos6502.Cpu6502;
import emulator.hardware.nmos6502.Flags6502;
import emulator.hardware.nmos6502.commands.CLD;
import emulator.unittest.hardware.nmos6502.MockOperand;

public class CLDTest {

	@Test
	public void testClearFromFalse() throws EmulatorException {
		Cpu6502 cpu = new Cpu6502();
		cpu.setFlags(new Flags6502(0));
		CLD cld = new CLD();
		cld.execute(cpu, new MockOperand(0));
		assertEquals(false, cpu.getFlags().getDecimal());
	}

	@Test
	public void testClearFromTrue() throws EmulatorException {
		Cpu6502 cpu = new Cpu6502();
		cpu.setFlags(new Flags6502(Flags6502.FLAG_DECIMAL));
		CLD cld = new CLD();
		cld.execute(cpu, new MockOperand(0));
		assertEquals(false, cpu.getFlags().getDecimal());
	}

}
