package emulator.unittest.hardware.nmos6502.commands;


import static org.junit.Assert.assertEquals;

import org.junit.Test;

import emulator.EmulatorException;
import emulator.hardware.HwByte;
import emulator.hardware.nmos6502.Cpu6502;
import emulator.hardware.nmos6502.Flags6502;
import emulator.hardware.nmos6502.commands.INY;
import emulator.hardware.nmos6502.operands.NoOperand;

public class INYTest {

	@Test
	public void testIncPositive() throws EmulatorException {
		executeAndCheckINY(0x3F, 0);
	}

	@Test
	public void testIncNegative() throws EmulatorException {
		executeAndCheckINY(0x7F, Flags6502.FLAG_NEGATIVE);
	}

	@Test
	public void testIncZero() throws EmulatorException {
		executeAndCheckINY(0xFF, Flags6502.FLAG_ZERO);
	}

	private void executeAndCheckINY(int x_val, int expected_flags)
			throws EmulatorException {
		Cpu6502 cpu = new Cpu6502();
		cpu.setY(new HwByte(x_val));
		new INY().execute(cpu, new NoOperand());
		assertEquals(new HwByte(x_val+1), cpu.getY());
		assertEquals(new Flags6502(expected_flags), cpu.getFlags());
	}

}
