package emulator.unittest.hardware.nmos6502.commands;

import org.junit.Before;
import org.junit.Test;

import emulator.EmulatorException;
import emulator.hardware.nmos6502.Flags6502;
import emulator.hardware.nmos6502.commands.LDY;

public class LDYTest extends CommandTestBase {

	@Before
	public void setUp() throws Exception {
		command = new LDY();
	}

	@Test
	public void testLoad() throws EmulatorException
	{
		executeAndCheckCommandOnY(command, 0, 0, 0x3f, 0, 0x3F);
	}

	@Test
	public void testLoadZero() throws EmulatorException
	{
		executeAndCheckCommandOnY(command, 0, 0x3F, 0, Flags6502.FLAG_ZERO, 0);
	}

	@Test
	public void testLoadNegative() throws EmulatorException
	{
		executeAndCheckCommandOnY(command, 0, 0x3F, 0x9F, Flags6502.FLAG_NEGATIVE, 0x9F);
	}

}
