package emulator.unittest.hardware.nmos6502.commands;

import org.junit.Test;
import static org.junit.Assert.assertEquals;
import emulator.EmulatorException;
import emulator.hardware.nmos6502.Cpu6502;
import emulator.hardware.nmos6502.Flags6502;
import emulator.hardware.nmos6502.commands.SEI;
import emulator.unittest.hardware.nmos6502.MockOperand;


public class SEITest {
	@Test
	public void testSetFlagFromFalse() throws EmulatorException {
		Cpu6502 cpu = new Cpu6502();
		cpu.setFlags(new Flags6502(0));
		SEI sei = new SEI();
		sei.execute(cpu, new MockOperand(0));
		assertEquals(true, cpu.getFlags().getInterrupt());
	}

	@Test
	public void testSetFlagFromTrue() throws EmulatorException {
		Cpu6502 cpu = new Cpu6502();
		cpu.setFlags(new Flags6502(Flags6502.FLAG_INTERRUPT));
		SEI sei = new SEI();
		sei.execute(cpu, new MockOperand(0));
		assertEquals(true, cpu.getFlags().getInterrupt());
	}
}
