package emulator.unittest.hardware.nmos6502.timing;

import static org.junit.Assert.assertEquals;

import org.junit.Before;
import org.junit.Test;

import emulator.EmulatorException;

public class AccumulatorTest {

	TimingTestBase test_base = null;
	
	@Before
	public void setUp() throws Exception {
		test_base = new TimingTestBase();
	}
	
	@Test
	public void testASL() throws EmulatorException
	{
		assertEquals(2, getCycles(0x0A));
	}

	@Test
	public void testLSR() throws EmulatorException
	{
		assertEquals(2, getCycles(0x4A));
	}

	@Test
	public void testROL() throws EmulatorException
	{
		assertEquals(2, getCycles(0x2A));
	}

	@Test
	public void testROR() throws EmulatorException
	{
		assertEquals(2, getCycles(0x6A));
	}

	private int getCycles(int opcode) throws EmulatorException
	{
		test_base.setCommand(0, opcode, 0, 0);
		test_base.execute();
		return test_base.getElapsedCycles();
	}
}
