package emulator.unittest.hardware.nmos6502.timing;

import static org.junit.Assert.assertEquals;

import org.junit.Before;
import org.junit.Test;

import emulator.EmulatorException;

public class ImmediateTest {

	TimingTestBase test_base = null;
	
	@Before
	public void setUp() throws Exception {
		test_base = new TimingTestBase();
	}
	
	@Test
	public void testADC() throws EmulatorException
	{
		assertEquals(2, getCycles(0x69));
	}

	@Test
	public void testAND() throws EmulatorException
	{
		assertEquals(2, getCycles(0x29));
	}

	@Test
	public void testCMP() throws EmulatorException
	{
		assertEquals(2, getCycles(0xC9));
	}

	@Test
	public void testCPX() throws EmulatorException
	{
		assertEquals(2, getCycles(0xE0));
	}

	@Test
	public void testCPY() throws EmulatorException
	{
		assertEquals(2, getCycles(0xC0));
	}

	@Test
	public void testEOR() throws EmulatorException
	{
		assertEquals(2, getCycles(0x49));
	}

	@Test
	public void testLDA() throws EmulatorException
	{
		assertEquals(2, getCycles(0xA9));
	}

	@Test
	public void testLDX() throws EmulatorException
	{
		assertEquals(2, getCycles(0xA2));
	}

	@Test
	public void testLDY() throws EmulatorException
	{
		assertEquals(2, getCycles(0xA0));
	}

	@Test
	public void testORA() throws EmulatorException
	{
		assertEquals(2, getCycles(0x09));
	}

	@Test
	public void testSBC() throws EmulatorException
	{
		assertEquals(2, getCycles(0xE9));
	}

	private int getCycles(int opcode) throws EmulatorException
	{
		test_base.setCommand(0, opcode, 0x44, 0);
		test_base.execute();
		return test_base.getElapsedCycles();
	}

}
