package emulator.util.file;

import java.io.File;

public class FileInfoP00 implements FileInfo {

	int block_size;
	
	public FileInfoP00(String file_name) {
		File file = new File(file_name);
		block_size = (int)file.length() - 0x1a;
	}

	@Override
	public int getBlockSize() {
		return block_size;
	}

	@Override
	public int getFormat() {
		return FileHelper.FILE_FORMAT_P00;
	}

	@Override
	public FileLoadStrategy getLoadStrategy() {
		return new FileLoadStrategySkipPrefix(0x1a);
	}

	@Override
	public int getStartAddress() {
		return 0;
	}

	@Override
	public FileSaveStrategy getSaveStrategy() {
		return null;
	}

}
