package emulator.util.file;

import java.io.FileOutputStream;
import java.io.IOException;

import emulator.hardware.memory.MemoryBlockInterface;
import emulator.shell.DebugShell;

public class FileSaveStrategyRaw implements FileSaveStrategy {

	@Override
	public void saveFromMemory(String file_name, MemoryBlockInterface memory,
			int start_address, int block_size) {
		FileOutputStream file = null;
		try
		{
			file = new FileOutputStream(file_name);
			memory.saveToStream(file, start_address, block_size);
		}
		catch (IOException e)
		{
			DebugShell.getInstance().getErr().println("File write failed for \""+file_name+"\" (raw): "+e.getMessage());
		}
		finally
		{
			if (file != null)
				try { file.close(); } catch (IOException e) {}
		}
	}

}
